diff -ruN bash-5.3-alpha-ori/command.h bash-5.3-alpha/command.h
--- bash-5.3-alpha-ori/command.h	2024-04-01 17:56:58.000000000 -0300
+++ bash-5.3-alpha/command.h	2024-10-15 23:43:10.514083312 -0300
@@ -27,7 +27,7 @@
 /* Instructions describing what kind of thing to do for a redirection. */
 enum r_instruction {
   r_output_direction, r_input_direction, r_inputa_direction,
-  r_appending_to, r_reading_until, r_reading_string,
+  r_appending_to, r_reading_until, r_reading_string,  r_reading_string_nolf,
   r_duplicating_input, r_duplicating_output, r_deblank_reading_until,
   r_close_this, r_err_and_out, r_input_output, r_output_force,
   r_duplicating_input_word, r_duplicating_output_word,
diff -ruN bash-5.3-alpha-ori/configure bash-5.3-alpha/configure
--- bash-5.3-alpha-ori/configure	2024-04-04 18:40:16.000000000 -0300
+++ bash-5.3-alpha/configure	2024-10-15 23:43:10.518083312 -0300
@@ -3212,7 +3212,7 @@
 
 
 BASHVERS=5.3
-RELSTATUS=alpha
+RELSTATUS=alpha+hs_nolf
 
 case "$RELSTATUS" in
 alp*|bet*|dev*|rc*|releng*|maint*)	DEBUG='-DDEBUG' MALLOC_DEBUG='-DMALLOC_DEBUG' ;;
diff -ruN bash-5.3-alpha-ori/copy_cmd.c bash-5.3-alpha/copy_cmd.c
--- bash-5.3-alpha-ori/copy_cmd.c	2022-12-29 20:21:49.000000000 -0300
+++ bash-5.3-alpha/copy_cmd.c	2024-10-15 23:43:10.519083312 -0300
@@ -128,6 +128,7 @@
       new_redirect->here_doc_eof = redirect->here_doc_eof ? savestring (redirect->here_doc_eof) : 0;
       /*FALLTHROUGH*/
     case r_reading_string:
+    case r_reading_string_nolf:
     case r_appending_to:
     case r_output_direction:
     case r_input_direction:
diff -ruN bash-5.3-alpha-ori/dispose_cmd.c bash-5.3-alpha/dispose_cmd.c
--- bash-5.3-alpha-ori/dispose_cmd.c	2023-03-29 17:53:52.000000000 -0300
+++ bash-5.3-alpha/dispose_cmd.c	2024-10-15 23:43:10.520083313 -0300
@@ -323,6 +323,7 @@
 	  free (t->here_doc_eof);
 	/*FALLTHROUGH*/
 	case r_reading_string:
+        case r_reading_string_nolf:
 	case r_output_direction:
 	case r_input_direction:
 	case r_inputa_direction:
diff -ruN bash-5.3-alpha-ori/make_cmd.c bash-5.3-alpha/make_cmd.c
--- bash-5.3-alpha-ori/make_cmd.c	2023-12-05 12:52:24.000000000 -0300
+++ bash-5.3-alpha/make_cmd.c	2024-10-15 23:43:10.520083313 -0300
@@ -686,6 +686,7 @@
     case r_deblank_reading_until: 	/* <<-foo */
     case r_reading_until:		/* << foo */
     case r_reading_string:		/* <<< foo */
+    case r_reading_string_nolf:		/* <<<- foo */
     case r_close_this:			/* <&- */
     case r_duplicating_input:		/* 1<&2 */
     case r_duplicating_output:		/* 1>&2 */
diff -ruN bash-5.3-alpha-ori/parse.y bash-5.3-alpha/parse.y
--- bash-5.3-alpha-ori/parse.y	2024-03-28 16:46:46.000000000 -0300
+++ bash-5.3-alpha/parse.y	2024-10-15 23:43:10.521083313 -0300
@@ -385,7 +385,7 @@
 %token <number> NUMBER
 %token <word_list> ARITH_CMD ARITH_FOR_EXPRS
 %token <command> COND_CMD
-%token AND_AND OR_OR GREATER_GREATER LESS_LESS LESS_AND LESS_LESS_LESS
+%token AND_AND OR_OR GREATER_GREATER LESS_LESS LESS_AND LESS_LESS_LESS LESS_LESS_LESS_MINUS
 %token GREATER_AND SEMI_SEMI SEMI_AND SEMI_SEMI_AND
 %token LESS_LESS_MINUS AND_GREATER AND_GREATER_GREATER LESS_GREATER
 %token GREATER_BAR BAR_AND
@@ -789,6 +789,24 @@
 			  redir.filename = $2;
 			  $$ = make_redirection (source, r_append_err_and_out, redir, 0);
 			}
+	|	LESS_LESS_LESS_MINUS WORD
+			{
+			  source.dest = 0;
+			  redir.filename = $2;
+			  $$ = make_redirection (source, r_reading_string_nolf, redir, 0);
+			}
+	|	NUMBER LESS_LESS_LESS_MINUS WORD
+			{
+			  source.dest = $1;
+			  redir.filename = $3;
+			  $$ = make_redirection (source, r_reading_string_nolf, redir, 0);
+			}
+	|	REDIR_WORD LESS_LESS_LESS_MINUS WORD
+			{
+			  source.filename = $1;
+			  redir.filename = $3;
+			  $$ = make_redirection (source, r_reading_string_nolf, redir, REDIR_VARASSIGN);
+			}
 	;
 
 simple_command_element: WORD
@@ -2340,6 +2358,7 @@
   { ";;&", SEMI_SEMI_AND },
   { "<<-", LESS_LESS_MINUS },
   { "<<<", LESS_LESS_LESS },
+  { "<<<-", LESS_LESS_LESS_MINUS },
   { "&>", AND_GREATER },
   { "&>>", AND_GREATER_GREATER },
   { "<>", LESS_GREATER },
@@ -3082,7 +3101,7 @@
   (token == '<' || token == '>' || \
    token == GREATER_GREATER || token == GREATER_BAR || \
    token == LESS_GREATER || token == LESS_LESS_MINUS || \
-   token == LESS_LESS || token == LESS_LESS_LESS || \
+   token == LESS_LESS || token == LESS_LESS_LESS || token == LESS_LESS_LESS_MINUS || \
    token == LESS_AND || token == GREATER_AND || token == AND_GREATER)
 
 /* Is `token' one that will allow a WORD to be read in a command position?
@@ -3615,13 +3634,20 @@
 	  switch (character)
 	    {
 	    case '<':
-	      /* If '<' then we could be at "<<" or at "<<-".  We have to
-		 look ahead one more character. */
+	      /* If '<' then we could be at "<<", "<<-", "<<<" or at "<<<-".  We have to
+		 look ahead one or two more characters. */
 	      peek_char = shell_getc (1);
 	      if MBTEST(peek_char == '-')
 		return (LESS_LESS_MINUS);
 	      else if MBTEST(peek_char == '<')
-		return (LESS_LESS_LESS);
+		{
+		  peek_char = shell_getc (1);
+		  shell_ungetc (peek_char);
+		  if MBTEST(peek_char == '-')
+		    return (LESS_LESS_LESS_MINUS);
+		  else
+		    return (LESS_LESS_LESS);
+		}
 	      else
 		{
 		  shell_ungetc (peek_char);
diff -ruN bash-5.3-alpha-ori/parser-built bash-5.3-alpha/parser-built
--- bash-5.3-alpha-ori/parser-built	2024-04-05 17:01:07.000000000 -0300
+++ bash-5.3-alpha/parser-built	2024-10-15 23:43:10.522083313 -0300
@@ -102,7 +102,8 @@
     BAR_AND = 303,                 /* BAR_AND  */
     DOLPAREN = 304,                /* DOLPAREN  */
     DOLBRACE = 305,                /* DOLBRACE  */
-    yacc_EOF = 306                 /* yacc_EOF  */
+    yacc_EOF = 306,                /* yacc_EOF  */
+    LESS_LESS_LESS_MINUS = 307     /* LESS_LESS_LESS_MINUS  */
   };
   typedef enum yytokentype yytoken_kind_t;
 #endif
@@ -160,6 +161,7 @@
 #define DOLPAREN 304
 #define DOLBRACE 305
 #define yacc_EOF 306
+#define LESS_LESS_LESS_MINUS 307
 
 /* Value type.  */
 #if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
diff -ruN bash-5.3-alpha-ori/print_cmd.c bash-5.3-alpha/print_cmd.c
--- bash-5.3-alpha-ori/print_cmd.c	2024-03-28 16:17:35.000000000 -0300
+++ bash-5.3-alpha/print_cmd.c	2024-10-15 23:43:10.522083313 -0300
@@ -1232,6 +1232,27 @@
 	cprintf ("<<< %s", redirect->redirectee.filename->word);
       break;
 
+    case r_reading_string_nolf:
+      if (redirect->rflags & REDIR_VARASSIGN)
+	cprintf ("{%s}", redir_word->word);
+      else if (redirector != 0)
+	cprintf ("%d", redirector);
+#if 0
+      /* Don't need to check whether or not to requote, since original quotes
+         are still intact.  The only thing that has happened is that $'...'
+         has been replaced with 'expanded ...'. */
+      if (ansic_shouldquote (redirect->redirectee.filename->word))
+	{
+	  char *x;
+	  x = ansic_quote (redirect->redirectee.filename->word, 0, (int *)0);
+	  cprintf ("<<<- %s", x);
+	  free (x);
+	}
+      else
+#endif
+	cprintf ("<<<- %s", redirect->redirectee.filename->word);
+      break;
+
     case r_duplicating_input:
       if (redirect->rflags & REDIR_VARASSIGN)
 	cprintf ("{%s}<&%d", redir_word->word, redir_fd);
diff -ruN bash-5.3-alpha-ori/redir.c bash-5.3-alpha/redir.c
--- bash-5.3-alpha-ori/redir.c	2024-02-02 12:16:07.000000000 -0300
+++ bash-5.3-alpha/redir.c	2024-10-15 23:43:10.522083313 -0300
@@ -358,7 +358,7 @@
     }
 
   /* Quoted here documents are not expanded */
-  if (ri != r_reading_string && (redirectee->flags & W_QUOTED))
+  if (ri != r_reading_string && ri != r_reading_string_nolf && (redirectee->flags & W_QUOTED))
     {
       if (lenp)
         *lenp = STRLEN (redirectee->word);
@@ -369,7 +369,7 @@
   /* Now that we've changed the variable search order to ignore the temp
      environment, see if we need to change the cached IFS values. */
   sv_ifs ("IFS");
-  document = (ri == r_reading_string) ? expand_assignment_string_to_string (redirectee->word, 0)
+  document = (ri == r_reading_string || ri == r_reading_string_nolf) ? expand_assignment_string_to_string (redirectee->word, 0)
   				      : expand_string_to_string (redirectee->word, Q_HERE_DOCUMENT);
   expanding_redir = 0;
   /* Now we need to change the variable search order back to include the temp
@@ -382,11 +382,12 @@
   executing_builtin = old;
 
   dlen = STRLEN (document);
-  /* XXX - Add trailing newline to here-string */
-  if (ri == r_reading_string)
+  /* XXX - Add trailing newline to here-string but not for here-string-nolf */
+  if (ri == r_reading_string || ri == r_reading_string_nolf)
     {
       document = xrealloc (document, dlen + 2);
-      document[dlen++] = '\n';
+      if (ri == r_reading_string)
+        document[dlen++] = '\n';
       document[dlen] = '\0';
     }
   if (lenp)
@@ -1014,6 +1015,7 @@
     case r_reading_until:
     case r_deblank_reading_until:
     case r_reading_string:
+    case r_reading_string_nolf:
       /* REDIRECTEE is a pointer to a WORD_DESC containing the text of
 	 the new input.  Place it in a temporary file. */
       if (redirectee)
@@ -1357,6 +1359,7 @@
     case r_reading_until:
     case r_deblank_reading_until:
     case r_reading_string:
+    case r_reading_string_nolf:
       return (1);
     case r_duplicating_input:
     case r_duplicating_input_word:
